#lang play
(require "machine.rkt")
;;;;;;;;;;;;;;;;;;;;;;;
;; Language definition
;;;;;;;;;;;;;;;;;;;;;;;

#|
<expr> ::= <num>
         | <bool>
         | <id>
         | {+ <expr> <expr>}
         | {- <expr> <expr>}
         | {= <expr> <expr>}
         | {< <expr> <expr>}
         | {and <expr> <expr>}
         | {or <expr> <expr>}
         | {not <expr>}
         | {if <expr> <expr> <expr>}
         | {with {<id> : <type> <expr>} <expr>}
         | {fun {<id> :<type>} [: <type>] <expr>}
         | {<expr> <expr>}         
 
<type> ::= Num
         | Bool
         | {<type> -> <type>}}
|#
(deftype Expr
  (num n)
  (bool b)
  (add l r)
  (sub l r)
  (my-eq l r)
  (my-less l r)
  (my-and l r)
  (my-or l r)
  (my-not e)
  (my-if c tb fb)
  (id s) 
  (fun id targ body tbody)
  (fun-db body)
  (acc n)
  (app fun-id arg-expr))

(deftype Type
  (TNum)
  (TBool)
  (TFun arg ret))

(define (parse-type s-expr) #f)

(define (parse s-expr)#f)

(define (deBruijn expr) #f)

(define (compile expr) #f)

(define (typeof expr) #f)

(define (typecheck s-expr) #f)

(define (typed-compile s-expr) #f)